<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_FlightSupplement ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_FlightSupplement extends AbstractStructArrayBase
{
    /**
     * The FlightSupplement
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_FlightSupplement[]
     */
    public $FlightSupplement;
    /**
     * Constructor method for ArrayOfJP_FlightSupplement
     * @uses ArrayOfJP_FlightSupplement::setFlightSupplement()
     * @param \StructType\JP_FlightSupplement[] $flightSupplement
     */
    public function __construct(array $flightSupplement = array())
    {
        $this
            ->setFlightSupplement($flightSupplement);
    }
    /**
     * Get FlightSupplement value
     * @return \StructType\JP_FlightSupplement[]|null
     */
    public function getFlightSupplement()
    {
        return $this->FlightSupplement;
    }
    /**
     * Set FlightSupplement value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_FlightSupplement[] $flightSupplement
     * @return \ArrayType\ArrayOfJP_FlightSupplement
     */
    public function setFlightSupplement(array $flightSupplement = array())
    {
        foreach ($flightSupplement as $arrayOfJP_FlightSupplementFlightSupplementItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_FlightSupplementFlightSupplementItem instanceof \StructType\JP_FlightSupplement) {
                throw new \InvalidArgumentException(sprintf('The FlightSupplement property can only contain items of \StructType\JP_FlightSupplement, "%s" given', is_object($arrayOfJP_FlightSupplementFlightSupplementItem) ? get_class($arrayOfJP_FlightSupplementFlightSupplementItem) : gettype($arrayOfJP_FlightSupplementFlightSupplementItem)), __LINE__);
            }
        }
        $this->FlightSupplement = $flightSupplement;
        return $this;
    }
    /**
     * Add item to FlightSupplement value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_FlightSupplement $item
     * @return \ArrayType\ArrayOfJP_FlightSupplement
     */
    public function addToFlightSupplement(\StructType\JP_FlightSupplement $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_FlightSupplement) {
            throw new \InvalidArgumentException(sprintf('The FlightSupplement property can only contain items of \StructType\JP_FlightSupplement, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->FlightSupplement[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_FlightSupplement|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_FlightSupplement|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_FlightSupplement|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_FlightSupplement|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_FlightSupplement|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FlightSupplement
     */
    public function getAttributeName()
    {
        return 'FlightSupplement';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_FlightSupplement
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
